unit setting;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, FileCtrl,
  Dialogs, StdCtrls, ExtCtrls, Registry, INIfiles, DSPack, DSUtil, DirectShow9;

type
  TfrmSet = class(TForm)
    GroupBox1: TGroupBox;
    VideoCapFilters: TListBox;
    VideoFormats: TListBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox2: TGroupBox;
    ePath: TEdit;
    Label1: TLabel;
    Button3: TButton;
    eName: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    Label5: TLabel;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    eInterval: TEdit;
    GroupBox4: TGroupBox;
    cbRun: TCheckBox;
    cbOnTop: TCheckBox;
    CaptureGraph: TFilterGraph;
    VideoSourceFilter: TFilter;
    rbOne: TCheckBox;
    brSerie: TCheckBox;
    procedure Startup();
    procedure Nacti();
    procedure Uloz();
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure VideoCapFiltersClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSet: TfrmSet;
  CapEnum: TSysDevEnum;
  VideoMediaTypes: TEnumMediaType;


implementation

uses main;
var frmMain: TVideoForm;


{$R *.dfm}

procedure TfrmSet.Button1Click(Sender: TObject);
begin
  close();
end;

procedure TfrmSet.Button2Click(Sender: TObject);
begin
  Startup();
  Uloz();
  close();
end;

procedure TfrmSet.Nacti();
var
  ini : TINIFile;
begin

  ini := TIniFile.Create(ExtractFilePath(application.ExeName) + 'setting.ini');

      ePath.Text := ini.ReadString('SNIMKY','Cesta','');
      eName.Text := ini.ReadString('SNIMKY','Jmeno','obrazek');
      eInterval.Text := ini.ReadString('SNIMKY','Interval','15');

      rbOne.Checked := ini.ReadBool('SNIMKY','JedenSnimek',true);
      brSerie.Checked := ini.ReadBool('SNIMKY','SerieSnimku',false);
      cbRun.Checked := ini.ReadBool('APP','SpoutetPriStartu',false);
      cbOnTop.Checked := ini.ReadBool('APP','VzdyNaVrchu',false);

      VideoCapFilters.ItemIndex := ini.ReadInteger('KAMERA','Index',0);
      VideoFormats.ItemIndex := ini.ReadInteger('KAMERA','Filter',0);


  ini.Free;

end;


procedure TfrmSet.Uloz();
var
  ini : TINIFile;
begin

  ini := TIniFile.Create(ExtractFilePath(application.ExeName) + 'Setting.ini');

    ini.WriteString('SNIMKY','Cesta',ePath.Text);
    ini.WriteString('SNIMKY','Jmeno',eName.Text);
    ini.WriteString('SNIMKY','Interval',eInterval.Text);

    ini.WriteBool('SNIMKY','JedenSnimek',rbOne.Checked);
    ini.WriteBool('SNIMKY','SerieSnimku',brSerie.Checked);
    ini.WriteBool('APP','SpoutetPriStartu',cbRun.Checked);
    ini.WriteBool('APP','VzdyNaVrchu',cbOnTop.Checked);

    ini.WriteInteger('KAMERA','Index', VideoCapFilters.ItemIndex);
    ini.WriteInteger('KAMERA','Filter', VideoFormats.ItemIndex);

    ini.UpdateFile;

  ini.Free;

end;


procedure TfrmSet.Startup();
var
  reg: TRegistry;
begin
  if cbRun.Checked = false then Begin
    reg := TRegistry.Create;
    reg.RootKey := HKEY_CURRENT_USER;
    reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run',true);
    reg.DeleteValue('TWebCam');
    reg.CloseKey;
    reg.Free;
  End
  Else Begin
    reg := TRegistry.Create;
    reg.RootKey := HKEY_CURRENT_USER;
    reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run',true);
    reg.WriteString('TWebCam',ParamStr(0));
    reg.CloseKey;
    reg.Free;
  End;
end;   




procedure TfrmSet.FormCreate(Sender: TObject);
var
  i : integer;
begin

  CapEnum := TSysDevEnum.Create(CLSID_VideoInputDeviceCategory);
  for i := 0 to CapEnum.CountFilters - 1 do
    VideoCapFilters.Items.Add(CapEnum.Filters[i].FriendlyName);

  VideoMediaTypes := TEnumMediaType.Create;

  Nacti();

end;

procedure TfrmSet.FormDestroy(Sender: TObject);
begin
  CapEnum.Free;
  VideoMediaTypes.Free;
end;

procedure TfrmSet.VideoCapFiltersClick(Sender: TObject);
var
  PinList: TPinList;
  i: integer;
begin
  CapEnum.SelectGUIDCategory(CLSID_VideoInputDeviceCategory);
  if VideoCapFilters.ItemIndex <> -1 then
  begin
    VideoSourceFilter.BaseFilter.Moniker := CapEnum.GetMoniker(VideoCapFilters.ItemIndex);
    VideoSourceFilter.FilterGraph := CaptureGraph;
    CaptureGraph.Active := true;
    PinList := TPinList.Create(VideoSourceFilter as IBaseFilter);
    VideoFormats.Clear;
    VideoMediaTypes.Assign(PinList.First);
    for i := 0 to VideoMediaTypes.Count - 1 do
      VideoFormats.Items.Add(VideoMediaTypes.MediaDescription[i]);
    CaptureGraph.Active := false;
    PinList.Free;
  end;
end;

procedure TfrmSet.Button3Click(Sender: TObject);
var
 pa: string;
begin

 if FileCtrl.SelectDirectory(pa, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   ePath.Text := pa;

end;

end.
